apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
{% if do_s3 %}
    backups.opsperator.io/driver: s3
{% else %}
    backups.opsperator.io/driver: ssh
{% endif %}
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
{% if not do_s3 %}
    backups.opsperator.io/secret: backups-{{ mastodon_name }}
    backups.opsperator.io/service: backups-{{ mastodon_name }}
{% elif mastodon_s3_flavor == 'minio' %}
    backups.opsperator.io/secret: {{ minio_name | default('s3') }}-mastodon
    backups.opsperator.io/service: {{ minio_name | default('s3') }}-client
{% elif mastodon_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
    backups.opsperator.io/secret: {{ rgw_name | default('s3') }}-mastodon
    backups.opsperator.io/service: {{ rgw_name | default('s3') }}
{% endif %}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ mastodon_name }}-job
  name: {{ mastodon_name }}-job
  namespace: {{ namespace }}
spec:
  replicas: 1
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ mastodon_name }}-job
  strategy:
{% if do_s3 %}
    type: RollingUpdate
{% else %}
    type: Recreate
{% endif %}
{% else %}
    name: {{ mastodon_name }}-job
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
{% if do_s3 %}
    rollingParams:
      timeoutSeconds: 1800
    type: Rolling
{% else %}
    recreateParams:
      timeoutSeconds: 1800
    type: Recreate
{% endif %}
{% endif %}
  template:
    metadata:
      labels:
        name: {{ mastodon_name }}-job
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ mastodon_name }}-job ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ mastodon_name }}-job ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: AWS_ACCESS_KEY_ID
{% if do_s3 %}
{% if mastodon_s3_flavor == 'minio' %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name | default('s3') }}-mastodon
        - name: AWS_SECRET_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name | default('s3') }}-mastodon
{% elif mastodon_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name | default('s3') }}-mastodon
        - name: AWS_SECRET_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name | default('s3') }}-mastodon
{% else %}
          value: ""
        - name: AWS_SECRET_ACCESS_KEY
          value: ""
{% endif %}
{% else %}
          value: ""
        - name: AWS_SECRET_ACCESS_KEY
          value: ""
{% endif %}
        - name: COMPONENT
          value: sidekiq
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ mtpg_name }}
        - name: DB_HOST
          value: {{ mtpg_name }}
        - name: DB_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ mtpg_name }}
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ mtpg_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: LOCAL_DOMAIN
          value: {{ mastodon_fqdn }}
        - name: OTP_SECRET
          valueFrom:
            secretKeyRef:
              key: otp-secret
              name: {{ mastodon_name }}
        - name: REDIS_HOST
          value: {{ cache_name }}
        - name: S3_BUCKET
{% if do_s3 %}
{% if mastodon_s3_flavor == 'minio' %}
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ minio_name | default('s3') }}-mastodon
        - name: S3_HOST
          value: {{ minio_api_address | urlsplit('hostname') }}
        - name: S3_PORT
          value: "{{ minio_api_address | urlsplit('port') }}"
        - name: S3_PROTOCOL
          value: "{{ minio_api_address | urlsplit('scheme') }}"
        - name: S3_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ minio_name | default('s3') }}-mastodon
        - name: S3_SIGNATURE_VERSION
          value: v2
        - name: S3_OVERRIDE_PATH_STYLE
          value: "true"
{% elif mastodon_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ rgw_name | default('s3') }}-mastodon
        - name: S3_HOST
          value: {{ radosgw_api_address | urlsplit('hostname') }}
        - name: S3_PORT
          value: "{{ radosgw_api_address | urlsplit('port') }}"
        - name: S3_PROTOCOL
          value: "{{ radosgw_api_address | urlsplit('scheme') }}"
        - name: S3_SIGNATURE_VERSION
          value: v2
        - name: S3_OVERRIDE_PATH_STYLE
          value: "true"
{% else %}
          value: ""
        - name: S3_HOST
          value: ""
        - name: S3_PORT
          value: ""
        - name: S3_PROTOCOL
          value: ""
        - name: S3_SIGNATURE_VERSION
          value: ""
        - name: S3_OVERRIDE_PATH_STYLE
          value: ""
{% endif %}
{% else %}
          value: ""
        - name: S3_HOST
          value: ""
        - name: S3_PORT
          value: ""
        - name: S3_PROTOCOL
          value: ""
        - name: S3_SIGNATURE_VERSION
          value: ""
        - name: S3_OVERRIDE_PATH_STYLE
          value: ""
{% endif %}
        - name: SECRET_KEY_BASE
          valueFrom:
            secretKeyRef:
              key: secret-key-base
              name: {{ mastodon_name }}
        - name: SMTP_FROM_ADDRESS
          value: noreply@{{ root_domain }}
        - name: SMTP_SERVER
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: peer
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
{% endif %}
        - name: TZ
          value: {{ timezone }}
        - name: VAPID_PRIVATE_KEY
          valueFrom:
            secretKeyRef:
              key: vapid-private
              name: {{ mastodon_name }}
        - name: VAPID_PUBLIC_KEY
          valueFrom:
            secretKeyRef:
              key: vapid-public
              name: {{ mastodon_name }}
{% if do_triggers == False or (opsimages | json_query("[?name=='mastodon'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='mastodon'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: sidekiq
        resources:
          limits:
            cpu: "{{ mastodon_sidekiq_cpu_limit }}"
            memory: "{{ mastodon_sidekiq_memory_limit }}"
          requests:
            cpu: "{{ mastodon_sidekiq_cpu_request }}"
            memory: "{{ mastodon_sidekiq_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
{% endif %}
        - mountPath: /opt/mastodon/public/system/accounts
          name: data
{% if do_backups and not do_s3 %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ mastodon_name }}-job
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if do_s3 %}
      - emptyDir: {}
        name: data
{% else %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ mastodon_name }}
{% endif %}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_lemon or do_ldap %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_backups and not do_s3 %}
      - name: ssh
        secret:
          secretName: backups-{{ mastodon_name }}
      - emptyDir: {}
        name: tmp
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='mastodon'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sidekiq
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='mastodon'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
